package com.supermap.samplecode.data;

/**
 * <p>
 * Title:投影转换
 * </p>
 * 
 * <p>
 * Description:
 * ============================================================================>
 * ------------------------------版权声明----------------------------
 * 此文件为SuperMap Objects Java 的示范代码 
 * 版权所有：北京超图软件股份有限公司
 * ----------------------------------------------------------------
 * ---------------------SuperMap iObjects Java 示范程序说明------------------------
 * 
 * 1、范例简介：展示投影转换；
 * 2、示例数据：安装目录\SampleData\China\China400.smwu;
 * 3、关键类型/成员: 
 *      CoordSysTranslator.convert 方法
 *      PrjCoordSys 类
 * 4、使用步骤：
 *  (1)点击高斯-克吕格投影转换按钮，显示投影转换结果
 *	(2)点击 UTM 投影转换按钮，显示投影转换结果
 * 	(3)点击兰勃托投影转换按钮，显示投影转换结果
 * ------------------------------------------------------------------------------
 * ============================================================================>
 * </p> 
 * 
 * <p>
 * Company: 北京超图软件股份有限公司
 * </p>
 * 
 */

/**
 * <p>
/**
 * <p>
 * Title:PrjCoordSysTransform
 * </p>
 * 
 * <p>
 * Description:
 * ============================================================================>
 * ------------------------------CopyRight----------------------------
 *This file contents the sample code of SuperMap Objects Java.
 * Copyright @2005-2012 SuperMap Software Co., Ltd. All Rights Reserved. 
 * ----------------------------------------------------------------
 * ---------------------SuperMap Objects Java Sample Code Description------------------------
 * 
 * 1.   Sample Code Description:  The following code demonstrates how to display the projection transform.
 * 2.  Sample Data:Installation directory\SampleData\China\China400.smwu;
 * 3.  Key Classes/Methods:
 *      CoordSysTranslator.convert 
 *      
 * 4.  Procedures
 *(1)Click "GKTransform" button, to display the result.
 *(2)Click "UTM Transform" button ,to display the result. 
 * (3)Click "Lambert Transform" button, to display the result.
 * ------------------------------------------------------------------------------
 * ============================================================================>
 * </p> 
 * 
 * <p>
 * Company:SuperMap Software Co., Ltd
 * </p>
 * 
 */

import javax.swing.JTextArea;

import com.supermap.data.CoordSysTransMethod;
import com.supermap.data.CoordSysTransParameter;
import com.supermap.data.CoordSysTranslator;
import com.supermap.data.Dataset;
import com.supermap.data.DatasetVector;
import com.supermap.data.Datasets;
import com.supermap.data.Datasource;
import com.supermap.data.EncodeType;
import com.supermap.data.GeoCoordSys;
import com.supermap.data.PrjCoordSys;
import com.supermap.data.PrjCoordSysType;
import com.supermap.data.PrjParameter;
import com.supermap.data.Projection;
import com.supermap.data.ProjectionType;
import com.supermap.data.Workspace;
import com.supermap.data.WorkspaceConnectionInfo;
import com.supermap.data.WorkspaceType;
import com.supermap.mapping.Map;
import com.supermap.ui.MapControl;

public class SampleRun {
	
	private Workspace m_workspace = null;
	
	private MapControl m_mapControlSrc = null;
	
	private MapControl m_mapControlDes = null;
	
	private JTextArea m_textAreaSrc = null;

	private JTextArea m_textAreaDes = null;
	
	private Map m_mapSrc = null;
	
	private Map m_mapDes = null;
	
	private Datasource m_datasource = null;
	
	private Datasets m_datasets = null;
	
	private Dataset m_dataset = null;
	
	private String m_resultName = null;
	
	private DatasetVector m_sourceDatasetCopy = null;
	
	private PrjCoordSys m_targetPrjCoordSys = null;
	
	private CoordSysTransParameter m_coordSysTransParameter = null;
	
	private String m_textArea1 = "";
	private String m_textArea2 = "";
	private String m_textArea3 = "";
	private String m_textArea4 = "";
	private String m_textArea5 = "";
	private String m_textArea6 = "";
	private String m_textArea7 = "";
	private String m_textArea8 = "";
	private String m_textArea9 = "";
	private String m_textArea10 = "";
	private String m_textArea11 = "";
	private String m_textArea12 = "";
	private String m_textArea13 = "";
	private String m_textArea14 = "";
	private String m_textArea15 = "";
	private String m_textArea16 = "";
	private String m_textArea17 = "";
	private String m_textArea18 = "";
	private String m_textArea19 = "";
	/**
	 * 根据workspace和map构造 SampleRun对象
	 * Initialize SampleRun object by the specified workspace and map object.
	 */
	public SampleRun(Workspace workspace, MapControl mapControlSrc,MapControl mapControlDes,JTextArea areaSrc, JTextArea areaDes){
		m_workspace = workspace;
		m_mapControlSrc = mapControlSrc;
		m_mapControlDes = mapControlDes;
		m_textAreaSrc = areaSrc;
		m_textAreaDes = areaDes;
		m_mapSrc = m_mapControlSrc.getMap();
		m_mapDes = m_mapControlDes.getMap();
		InitializeCultureResources();
		initialize();
	}

	/**
	* 初始化多语言资源
	* Initialize CultureResources
	*/
	private void InitializeCultureResources()
	{
		if(com.supermap.data.Environment.getCurrentCulture().contentEquals("zh-CN"))
		{
			m_textArea1 = "当前投影信息如下：\n";
			m_textArea2 = "投影名称：";
			m_textArea3 = "投影类型：";
			m_textArea4 = "中央经线：";
			m_textArea5 = "原点维度：";
			m_textArea6 = "第一标准纬线：";
			m_textArea7 = "第二标准纬线：";
			m_textArea8 = "水平偏移量：";
			m_textArea9 = "垂直偏移量：";
			m_textArea10 = "比例因子：";
			m_textArea11 = "方位角：";
			m_textArea12 = "第一点经线：";
			m_textArea13 = "第二点经线：";
			m_textArea14 = "地理坐标系：";
			m_textArea15 = "大地参照系：";
			m_textArea16 = "参考椭球体：";
			m_textArea17 = "椭球长半轴：";
			m_textArea18 = "椭球扁率：";
			m_textArea19 = "本初子午线：";
		}
		else
		{
			m_textArea1 = "Current PrjCoordSys information as below:\n";
			m_textArea2 = "Projection name:";
			m_textArea3 = "Projection type:";
			m_textArea4 = "Central meridian:";
			m_textArea5 = "Central parallel:";
			m_textArea6 = "The first standard parallel:";
			m_textArea7 = "The second standard parallel:";
			m_textArea8 = "False Easting:";
			m_textArea9 = "False Northing:";
			m_textArea10 = "Scale factor:";
			m_textArea11 = "Azimuth:";
			m_textArea12 = "The first point longitude:";
			m_textArea13 = "The second point longitude:";
			m_textArea14 = "Geofraphic Coordinate system:";
			m_textArea15 = "Geographic datum system:";
			m_textArea16 = "Geographic spheroid:";
			m_textArea17 = "Spheroidal axis:";
			m_textArea18 = "Spheroidal flatten:";
			m_textArea19 = "Prime Meridian:";
		}
	}

	/**
	 * 执行SmapleRun的初始化 
	 * Initialize SmapleRun object. 
	 */
	private void initialize() {
			// 打开工作空间和地图
			// Open workspace and map.
		try{
			WorkspaceConnectionInfo conInfo = new WorkspaceConnectionInfo(
			 "../../SampleData/China/China400.smwu");
			conInfo.setType(WorkspaceType.SMWU);
			m_workspace.open(conInfo);
			m_datasource = m_workspace.getDatasources().get(0);
			m_datasets = m_workspace.getDatasources().get(0).getDatasets();
			m_dataset = (DatasetVector)m_datasets.get("County_R");
			m_resultName = "outPutDataset";
			m_mapDes.setWorkspace(m_workspace);
			m_mapSrc.setWorkspace(m_workspace);
			m_mapSrc.getLayers().add(m_dataset, true);
			m_mapSrc.viewEntire();
			m_mapSrc.refresh();
			prjCoordSysPrint(m_dataset,m_textAreaSrc);
		}catch (Exception e){
			e.printStackTrace();
		}
	}
	
	/**
	 * 执行投影转换
	 * Projection coordinate transform.
	 */
	public void transform(int type){
		try{
			mapDesReset();
			CoordSysTranslator.convert(m_sourceDatasetCopy, getTargetPrjCoordSys(type), getcoordSysTransParameter(), CoordSysTransMethod.MTH_GEOCENTRIC_TRANSLATION);
			prjCoordSysPrint(m_sourceDatasetCopy,m_textAreaDes);
			m_mapDes.getLayers().add(m_sourceDatasetCopy, true);
			m_mapDes.setCenter(m_mapDes.getBounds().getCenter());
			m_mapDes.setScale(m_mapSrc.getScale());
			m_mapDes.refresh();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	/**
	 * 按照不同的投影类型，初始化投影坐标系
	 * Initialize the projection coordinates by the different projection type.
	 */
	private PrjCoordSys getTargetPrjCoordSys(int type){
		PrjParameter parameter;
		Projection projection;
			switch(type){
			case 1:
				m_targetPrjCoordSys = new PrjCoordSys(PrjCoordSysType.PCS_USER_DEFINED);
				projection = new Projection(ProjectionType.PRJ_GAUSS_KRUGER);
				m_targetPrjCoordSys.setProjection(projection);
				parameter = new PrjParameter();
				parameter.setCentralMeridian(110);
				parameter.setStandardParallel1(20);
				parameter.setStandardParallel2(40);
				m_targetPrjCoordSys.setPrjParameter(parameter);
				break;
				
			case 2:
				m_targetPrjCoordSys = new PrjCoordSys(PrjCoordSysType.PCS_USER_DEFINED);
				projection = new Projection(ProjectionType.PRJ_TRANSVERSE_MERCATOR);
				m_targetPrjCoordSys.setProjection(projection);
				parameter = new PrjParameter();
				parameter.setCentralMeridian(110);
				parameter.setStandardParallel1(0);
				m_targetPrjCoordSys.setPrjParameter(parameter);
				break;
				
			case 3:
				m_targetPrjCoordSys = new PrjCoordSys(PrjCoordSysType.PCS_USER_DEFINED);
				projection = new Projection(ProjectionType.PRJ_LAMBERT_CONFORMAL_CONIC);
				m_targetPrjCoordSys.setProjection(projection);
				parameter = new PrjParameter();
				parameter.setCentralMeridian(110);
				parameter.setStandardParallel1(30);
				m_targetPrjCoordSys.setPrjParameter(parameter);
				break;
				
			default:
				break;
			}
		return m_targetPrjCoordSys;
	}
	
	/**
	 * 初始化投影转换参数
	 */
	private CoordSysTransParameter getcoordSysTransParameter(){
		if (m_coordSysTransParameter == null) {
			m_coordSysTransParameter = new CoordSysTransParameter();
		}
		
		return m_coordSysTransParameter;
	}
	
	/**
	 * 重置目标地图窗口和目标投影信息显示窗口
	 * Reset the target map form and the target projection information form.
	 */
	private void mapDesReset(){
		try{
			m_mapDes.getLayers().clear();
			m_datasets.delete(m_resultName);
			m_sourceDatasetCopy = (DatasetVector)m_dataset.getDatasource().copyDataset(m_dataset, m_resultName, EncodeType.NONE);
			m_textAreaDes.setText("");
			m_mapDes.getLayers().add(m_sourceDatasetCopy, true);
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	/**
	 * 输出投影信息 
	 * Output projection information. 
	 */
	private void prjCoordSysPrint(Dataset dataset,JTextArea textArea) {
		try{
			PrjCoordSys prjCoordSys = dataset.getPrjCoordSys();
			PrjParameter prjParameter = prjCoordSys.getPrjParameter();
			GeoCoordSys geoCoordSys = prjCoordSys.getGeoCoordSys();
			
			textArea.append(m_textArea1);
			printMessage(textArea,m_textArea2+prjCoordSys.getName().toString());
			printMessage(textArea,m_textArea3+prjCoordSys.getProjection().getName().toString());
			printMessage(textArea,m_textArea4+prjParameter.getCentralMeridian());
			printMessage(textArea,m_textArea5+prjParameter.getCentralParallel());
			printMessage(textArea,m_textArea6+prjParameter.getStandardParallel1());
			printMessage(textArea,m_textArea7+prjParameter.getStandardParallel2());
			printMessage(textArea,m_textArea8+prjParameter.getFalseEasting());
			printMessage(textArea,m_textArea9+prjParameter.getFalseNorthing());
			printMessage(textArea,m_textArea10+prjParameter.getScaleFactor());
			printMessage(textArea,m_textArea11+prjParameter.getAzimuth());
			printMessage(textArea,m_textArea12+prjParameter.getFirstPointLongitude());
			printMessage(textArea,m_textArea13+prjParameter.getSecondPointLongitude());
			
			printMessage(textArea,m_textArea14+geoCoordSys.getName());
			printMessage(textArea,m_textArea15+geoCoordSys.getGeoDatum().getName());
			printMessage(textArea,m_textArea16+geoCoordSys.getGeoDatum().getGeoSpheroid().getName());
			printMessage(textArea,m_textArea17+geoCoordSys.getGeoDatum().getGeoSpheroid().getAxis());
			printMessage(textArea,m_textArea18+geoCoordSys.getGeoDatum().getGeoSpheroid().getFlatten());
			printMessage(textArea,m_textArea19+geoCoordSys.getGeoPrimeMeridian().getLongitudeValue());
		
		
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	/**
	 * 将文本输出到界面中的文本框 
	 * Output the text in the message box.
	 */
	public void printMessage(JTextArea textArea,String message) {
		try{
			textArea.append(message + "\n");
			textArea.moveCaretPosition(textArea.getText().length() - 0);
		}catch(Exception e){
			e.printStackTrace();
		}
	}



}

